Subject: RE: [Diffserv] Comments on draft-charny-ef-definition-00

From: "Kent Benson" <[email-masked]>
Date: Wed, 26 Jul 2000 10:30:36 -0500

There appears to be a lot of opinions on how to interpret this sentence from
RFC 2598:

"It SHOULD average at least the configured rate when measured over any time
interval equal to or longer than the time it takes to send an output link
MTU sized packet at the configured rate"

If Van, Kathie and/or Kedar could comment on its meaning I think it would be
quite helpful.

Thanks,
Kent

>-----Original Message-----
>From: [email-masked] [mailto:[email-masked]]On Behalf
>Of [email-masked]
>Sent: Tuesday, July 25, 2000 4:40 PM
>To: [email-masked]; [email-masked]
>Subject: RE: [Diffserv] Comments on draft-charny-ef-definition-00
>
>
>Hi Kathy,
>
>I hope you could at least reply to this email. I won't go to
>the details
>now, but just want to make things clear. Are you suggesting that the
>following EF statements are fine an implementable?
>
>"the departure rate of the aggregate's packets from any
>diffserv node MUST
>equal or exceed a configurable rate".
>
>"It SHOULD average at least the configured rate when measured over any
>time interval equal to or longer than the time it takes to
>send an output
>link MTU sized packet at the configured rate"
>
>If so, why don't you explain how these statements apply to the
>examples in
>section 1.2.1, 1.2.2 of Charney draft, and show that they are indeed EF
>conformant.
>
>Regards,
>-Shahram
>

_______________________________________________
diffserv mailing list
[email-masked]
http://www1.ietf.org/mailman/listinfo/diffserv
Archive: http://www-nrg.ee.lbl.gov/diff-serv-arch/

---

From: Jon Bennett <[email-masked]>
Date: Thu, 27 Jul 2000 13:04:08 -0400

Kathleen,

This is a response to your first message from yesterday with the
modified text that you sent later in the day.

While my understanding of RFC 2598 is such that I can not see how 
what you describe in this message is exactly the definition in
RFC 2598, I will accept your claim that it is for the sake of
argument. At the end of this message I have put a question based on
your statement that this definition is the same as RFC 2598 which
I suspect may clarify things. I would appreciate if you could either
answer the question directly or explain any flaws in the way the
question is stated that prevent it being answered directly.

> Say i(t) is the total number of EF marked bits destined for a
> particular output interface that arrive between t and t+dt, o(t) is
> the number departing on that interface. Further define r(t) as the
> rate deficit, [i(t) - o(t)]. The rate deficit arises from bits in
> transit through the router and includes bits that never emerge, 
> the router drops.
> Define:
> 
>   I(T) = \int_0^T i(t)dt 
> 
> (the \int_0^T is TeX notation for "definite integral from 0 to T" so
> this is the total number of bits that go in measured from 
> time 0 to time
> T) and R(T) and O(T) similarly. Then it's always true that:
> 
>   O(T) = I(T) + R(T)    [eq.1]

since R(T) = \int_0^T [i(t) - o(t)] , R(T) should be [I(t) - O(t)]
so you probably ment [eq.1] to be

O(T) = I(T) - R(T)

i.e. the total bits out is equal to the total bits in *minus* the bits 
inside the router not *plus* the bits in the router. It ok though I 
think I have the right intuition about what you meant to say :-)
(this doesn't have anything to do with my question below, its just a 
 clarification question)

> Since the above only says that R() has to be bounded, you can make a low
> loss behavior by policing the average input rate to something less than
> the achievable output rate then sticking enough buffer in the router to
> handle the worst case (measured) transit time. While this is a well
> defined behavior, it is *not* the EF behavior since it provides no
> contraints on jitter.
...
> If, however, you measure the worst case R() then
> constrain the input rates such that I(T)+R(T) <= 1 packet, you get
> something that both has an explicit jitter bound for SLAs and has a very
> simple algebraic structure under aggregation (described in detail in the
> VW PDB document). This constraint is the same as saying there's at most
> one packet entering + in the router when measured over a packet time at
> the configured output link rate. I.e., this is exactly the definition in
> RFC 2598.

As I see it, you are stating that it is a restriction/requirement of the EF 
PHB that at no point in time should there be more than one EF packet in the 
router (we don't care about packets in the process of coming or going). 

In other words;

"If the EF queue size were limited to 1 packet (or some small fixed number
of packets, e.g. 2-3) then there would never be an EF packet dropped due 
to queue overflow."

Is this understanding of your message and its statements correct?

 You may assume that the output link is served in whatever you think is the 
 appropriate way, you may even assume that there is no non-EF traffic, and 
 that the internal behavior of the router packet processing is also ideal, 
 however it is that you define it. I am only trying to ask a question about 
 the nature of the input restriction that you have clarified in your
message.

jon